#ifndef BTINYEDITORAPP 
#define BTINYEDITORAPP 
//--------------------------------------------------------------------- 
#include <Be.h> 
#include "MainWindow.h" 
//--------------------------------------------------------------------- 
#define APPLICATION_SIGNATURE   "application/x-vnd.vow-betinyeditor" 
//--------------------------------------------------------------------- 
class BTinyEditorApp : public BApplication 
{ 
private: 
    BFilePanel *open_filepanel; 
public: 
    BTinyEditorApp() 
        :BApplication(APPLICATION_SIGNATURE) 
    { 
        BEditorWindow *mainwnd=new BEditorWindow( 
            BRect(MAINWINDOW_POSITION_LEFT,MAINWINDOW_POSITION_TOP, 
                  MAINWINDOW_POSITION_WIDTH+MAINWINDOW_POSITION_LEFT-1, 
                  MAINWINDOW_POSITION_HEIGHT+MAINWINDOW_POSITION_TOP-1), 
            MAINWINDOW_TITLE); 
        
        open_filepanel= new BFilePanel(); 
        mainwnd->Show(); 
    }; 
    //----------------------------------------------------------------- 
    ~BTinyEditorApp() 
    { 
        delete open_filepanel; 
    }; 
    //----------------------------------------------------------------- 
    void MessageReceived(BMessage *msg) 
    { 
        switch(msg->what) 
        {        
            case MSG_OPEN: 
                open_filepanel->Show(); 
                break; 
            default: 
                BApplication::MessageReceived(msg); 
        } 
    }; 
    //----------------------------------------------------------------- 
    void RefsReceived(BMessage *message) 
    { 
        type_code ref_type; 
        int32 ref_count; 
        entry_ref ref; 
        BEntry entry; 
        
        message->GetInfo("refs", &ref_type,&ref_count); 
        for (int i=0;i<ref_count;i++) 
        { 
            message->FindRef("refs",i,&ref); 
            if(entry.SetTo(&ref)==B_OK) 
            { 
                WindowAt(0)->Lock(); 
                ((BEditorWindow *)WindowAt(0))->OpenFile(&entry); 
                WindowAt(0)->Unlock(); 
                return; 
            } 
        } 
    } 
}; 
//--------------------------------------------------------------------- 
#endif 